#ifndef	_TRACE_H
#define	_TRACE_H

#ifndef	_MBUF_H
#include "mbuf.h"
#endif

#ifndef	_IFACE_H
#include "iface.h"
#endif

/* Definitions for packet dumping */

/* Table of trace subcommands */
struct tracecmd {
	char *name;	/* Name of trace subcommand */
	int val;	/* New setting for these bits */
	int mask;	/* Mask of bits affected in trace word */
};
extern struct tracecmd Tracecmd[];	/* Defined in trace.c */

/* List of address testing and tracing functions for each interface.
 * Entries are placed in this table by conditional compilation in main.c.
 */
struct trace {
	int (*addrtest) __ARGS((struct iface *ifp,struct mbuf *bp));
#ifdef MONITOR
	void (*tracef) __ARGS((FILE *,struct mbuf **,int,int));
#else
	void (*tracef) __ARGS((FILE *,struct mbuf **,int));
#endif
};

extern struct trace Tracef[];

/* In trace.c: */
void dump __ARGS((struct iface *ifp,int direction,unsigned type,struct mbuf *bp));
void raw_dump __ARGS((struct iface *ifp,int direction, struct mbuf *bp));
void trace_log __ARGS((struct iface *ifp,char *fmt, ...));
void shuttrace __ARGS ((void));

/* In arcdump.c: */
#ifdef MONITOR
void arc_dump __ARGS((FILE *fp,struct mbuf **bpp,int check,int mon));
#else
void arc_dump __ARGS((FILE *fp,struct mbuf **bpp,int check));
#endif
int arc_forus __ARGS((struct iface *iface,struct mbuf *bp));

/* In arpdump.c: */
#ifdef MONITOR
void arp_dump __ARGS((FILE *fp,struct mbuf **bpp,int mon));
#else
void arp_dump __ARGS((FILE *fp,struct mbuf **bpp));
#endif

/* In ax25dump.c: */
#ifdef MONITOR
void ax25_dump __ARGS((FILE *fp,struct mbuf **bpp,int check,int mon));
#else
void ax25_dump __ARGS((FILE *fp,struct mbuf **bpp,int check));
#endif
int ax_forus __ARGS((struct iface *iface,struct mbuf *bp));

/* In enetdump.c: */
#ifdef MONITOR
void ether_dump __ARGS((FILE *fp,struct mbuf **bpp,int check,int mon));
#else
void ether_dump __ARGS((FILE *fp,struct mbuf **bpp,int check));
#endif
int ether_forus __ARGS((struct iface *iface,struct mbuf *bp));

/* In icmpdump.c: */
#ifdef MONITOR
void icmp_dump __ARGS((FILE *fp,struct mbuf **bpp,int32 source,int32 dest,int check,int mon));
#else
void icmp_dump __ARGS((FILE *fp,struct mbuf **bpp,int32 source,int32 dest,int check));
#endif

/* In ipdump.c: */
#ifdef MONITOR
void ip_dump __ARGS((FILE *fp,struct mbuf **bpp,int check,int mon));
#else
void ip_dump __ARGS((FILE *fp,struct mbuf **bpp,int check));
#endif

/* In kissdump.c: */
#ifdef MONITOR
void ki_dump __ARGS((FILE *fp,struct mbuf **bpp,int check,int mon));
#else
void ki_dump __ARGS((FILE *fp,struct mbuf **bpp,int check));
#endif
int ki_forus __ARGS((struct iface *iface,struct mbuf *bp));

/* In nrdump.c: */
#ifdef MONITOR
void netrom_dump __ARGS((FILE *fp,struct mbuf **bpp,int check,int mon));
#else
void netrom_dump __ARGS((FILE *fp,struct mbuf **bpp,int check));
#endif

/* In pppdump.c: */
#ifdef MONITOR
void ppp_dump __ARGS((FILE *fp,struct mbuf **bpp,int check,int mon));
#else
void ppp_dump __ARGS((FILE *fp,struct mbuf **bpp,int check));
#endif

/* In ripdump.c: */
#ifdef MONITOR
void rip_dump __ARGS((FILE *fp,struct mbuf **bpp,int mon));
#else
void rip_dump __ARGS((FILE *fp,struct mbuf **bpp));
#endif

/* In ripdump.c: */
#ifdef MONITOR
void rspf_dump __ARGS((FILE *fp,struct mbuf **bpp,int32 source,int32 dest,int check,int mon));
#else
void rspf_dump __ARGS((FILE *fp,struct mbuf **bpp,int32 source,int32 dest,int check));
#endif

/* In slcompdump.c: */
#ifdef MONITOR
void sl_dump __ARGS((FILE *fp,struct mbuf **bpp,int check,int mon));
void vjcomp_dump __ARGS((FILE *fp,struct mbuf **bpp,int unused,int mon));
#else
void sl_dump __ARGS((FILE *fp,struct mbuf **bpp,int check));
void vjcomp_dump __ARGS((FILE *fp,struct mbuf **bpp,int unused));
#endif

/* In tcpdump.c: */
#ifdef MONITOR
void tcp_dump __ARGS((FILE *fp,struct mbuf **bpp,int32 source,int32 dest,int check,int mon));
#else
void tcp_dump __ARGS((FILE *fp,struct mbuf **bpp,int32 source,int32 dest,int check));
#endif

/* In udpdump.c: */
#ifdef MONITOR
void udp_dump __ARGS((FILE *fp,struct mbuf **bpp,int32 source,int32 dest,int check,int mon));
#else
void udp_dump __ARGS((FILE *fp,struct mbuf **bpp,int32 source,int32 dest,int check));
#endif

#ifdef UNIX
#define fprintf traceprintf
#endif

#endif	/* _TRACE_H */
