/* Version control information for "info" command display */
/* Definition for processor type added */
/* Cleanup of information display - K2MF 4/93 */

#include <string.h> 
#include "config.h"
#include "global.h"
#include "mbuf.h"
#include "socket.h"
#include "version.h"
#include "commands.h"

/* NOTE - the following string must be large enough to hold data below */

char Version[30];
char shortversion[] = "JNOS1.09a4";

#if (defined(MAILBOX) || defined(MBFWD))
char MboxId[] = "[JNOS-1.09-HM$]\n";
#endif /* MAILBOX || MBFWD */

char Version2[] = "by Johan Reinalda, WG7J/PA3DIS\n";
extern int Numrows,Numcols,Nusock;

/* ifdef versions defined in makefile */
void setversion(void)
{
    strcpy(Version,"911229 (WG7J v1.09");

#if defined UNIX
    strcat(Version,"a4-Unix)");
#elif defined CPU286
    strcat(Version,"-80186)");
#elif defined CPU386
    strcat(Version,"-80386)");
#else
    strcat(Version,"-8088)");
#endif
}

#ifdef ALLCMD
int
#ifdef PROTOTYPES
doinfo(int argc,char **argv,void *p)
#else
doinfo(argc,argv,p)
int argc;
char *argv[];
void *p;
#endif
{
    tprintf("NOS %s, compiled %s %s containing:\n\n" ,Version,__DATE__,__TIME__);

	tputs("TCP Servers:");

#ifndef SERVERS
	tputs("  None !\n");
#endif /* ! SERVERS */

#ifdef SERVERS
	tputs("  FINGER  SMTP  FTP");

#ifdef MAILBOX
	tputs("  TELNET");
#endif /* MAILBOX */

#ifdef ALLSERV
	tputs("  TTYLINK  DISCARD  ECHO");
#endif /* ALLSERV */

	tputs("\n");

#if (defined(CALLSERVER) || defined(CONVERS) || defined(NNTPS) || defined(POP2SERVER) || defined(POP3SERVER) || defined(RDATE))
	tputs("            ");

#ifdef CALLSERVER
	tputs("  CALLBOOK (CD-ROM)");
#endif /* CALLSERVER */

#ifdef CONVERS
	tputs("  CONVERS");
#endif /* CONVERS */

#ifdef NNTPS
	tputs("  NNTP");
#endif /* NNTPS */

#ifdef POP2SERVER
	tputs("  POP2");
#endif /* POP2SERVER */

#ifdef POP3SERVER
	tputs("  POP3");
#endif /* POP3SERVER */

#ifdef RDATE
	tputs ("  TIME");
#endif /* RDATE */

	tputs ("\n");
#endif /* CALLSERVER || CONVERS || NNTPS || POP2SERVER || POP3SERVER || RDATE */

#endif /* SERVERS */

	tputs("TCP Clients:  FINGER  SMTP");

#ifdef ALLSESSIONS
	tputs("  FTP  TELNET");
#endif /* ALLSESSIONS */

#ifdef ALLSERV
	tputs("  TTYLINK");
#endif /* ALLSERV */

	tputs ("\n");

#if (defined(CALLCLI) || defined(CONVERS) || defined(NNTP) || defined(NNTPS) || defined(POP2CLIENT) || defined(POP3CLIENT) || defined(RLOGINCLI) || defined(RDATE))
	tputs ("            ");

#ifdef CALLCLI
	tputs("  CALLBOOK (CD-ROM)");
#endif /* CALLCLI */

#ifdef CONVERS
	tputs("  CONVERS");
#endif /* CONVERS */

#if (defined(NNTP) || defined(NNTPS))
	tputs("  NNTP");
#endif /* NNTP || NNTPS */

#ifdef POP2CLIENT
	tputs("  POP2");
#endif /* POP2CLIENT */

#ifdef POP3CLIENT
	tputs("  POP3");
#endif /* POP3CLIENT */

#ifdef RLOGINCLI
	tputs("  RLOGIN");
#endif /* RLOGINCLI */

#ifdef RDATE
	tputs ("  TIME");
#endif /* RDATE */

	tputs ("\n");
#endif /* CALLCLI || CONVERS || NNTP || NNTPS || POP2CLIENT || POP3CLIENT || RLOGINCLI || RDATE */

#ifdef LZW
    tputs("    with LZW compression for TCP sockets\n");
#endif /* LZW */

#if (defined(TCPACCESS) || defined(IPACCESS))
	tputs("    with ");

#ifdef TCPACCESS
	tputs("TCP");
#endif /* TCPACCESS */

#if (defined(TCPACCESS) && defined(IPACCESS))
	tputs("/");
#endif /* TCPACCESS && IPACCESS */

#ifdef IPACCESS
    tputs("IP");
#endif /* IPACCESS */

	tputs(" access controls\n");
#endif /* TCPACCESS || IPACCESS */

	tputs("UDP Servers:");

#if (!defined(DSERVER) && !defined(SERVERS))
	tputs("  None !");
#endif /* ! DSERVER && ! SERVERS */

#ifdef DSERVER
	tputs("  DOMAIN NAMESERVER");
#endif /* DSERVER */

#ifdef SERVERS
	tputs("  REMOTE");
#endif /* SERVERS */

	tputs("\n");

#ifdef MAILBOX

#ifdef TIPMAIL
	tputs("TIP ");
#endif /* TIPMAIL */

	tputs("Mailbox Server");

#ifdef XMODEM
	tputs(" with Xmodem file transfer");
#endif /* XMODEM */

	tputs("\n");

#ifdef MAILCMDS
	tputs("Full Service BBS");

#if (defined(EXPIRY) || defined(MAILFOR) || defined(MBFWD) || defined(RLINE))
	tputs(" with:");
#endif /* EXPIRY || MAILFOR || MBFWD || RLINE */

#ifdef EXPIRY
	tputs("\n     Message and BID expiry");
#endif /* EXPIRY */

#ifdef MAILFOR
	tputs("\n     'Mail For' beaconing");
#endif /* MAILFOR */

#ifdef MBFWD
	tputs("\n     AX.25 mail forwarding");
#endif /* MBFWD */

#ifdef RLINE
	tputs("\n     BBS 'R:-line' compatibility");
#endif /* RLINE */

	tputs("\n");
#endif /* MAILCMDS */

#endif /* MAILBOX */

#if (defined(CALLBOOK) || defined(AXIP) || defined(ENCAP))
	tputs("Internet Services:");

#ifdef CALLBOOK
	tputs("  BBS Callbook Client");
#endif /* CALLBOOK */

#ifdef AXIP
	tputs("  AX.25 Digipeating");
#endif /* AXIP */

#ifdef ENCAP
	tputs("  IP Encapsulation");
#endif /* ENCAP */

	tputs("\n");
#endif /* CALLBOOK || AXIP || ENCAP */

#ifdef HOPCHECK
	tputs("Hopcheck IP path tracing\n");
#endif /* HOPCHECK */

#ifdef RIP
	tputs("RIP Routing Protocol\n");
#endif /* RIP */

#ifdef RSPF
	tputs("Radio Shortest Path First Protocol (RSPF)\n");
#endif /* RSPF */

#ifdef RARP
	tputs("Reverse Address Resolution Protocol (RARP)\n");
#endif /* RARP */

#ifdef UNIX
	tprintf("%d sockets\n",Nusock);
#else
	tprintf("%d sockets, %d interrupt buffers of %d bytes\n",Nusock,Nibufs,Ibufsize);
#endif

#ifdef ASY
#ifdef UNIX
	tputs("Generic termios interface driver\n");
#else
	tputs("Generic async (8250/16450/16550) interface driver\n");
#endif

#if (defined(KISS) || defined(AX25) || defined(NRS))
	tputs("Async interface drivers:");

#ifdef KISS
	tputs("  KISS TNC");
#endif /* KISS */

#ifdef AX25
	tputs("  AX.25");
#endif /* AX25 */

#ifdef NRS
	tputs("  NET/ROM TNC");
#endif /* NRS */

	tputs("\n");
#endif /* KISS || AX25 || NRS */

#endif /* ASY */

#ifdef NETROM
	tputs("NET/ROM network interface\n");
#endif /* NETROM */

#if (defined(PPP) || defined(SLIP))
	tputs("Async IP drivers:");

#ifdef PPP
	tputs("  Point-to-Point (PPP)");
#endif /* PPP */

#ifdef SLIP
	tputs("  Serial Line (SLIP)");
#endif /* SLIP */

	tputs("\n");
#ifdef DIALER
    tputs("      with dialer code for SLIP\n");
#endif /* DIALER */

#ifdef VJCOMPRESS
    tputs("      with Van Jacobson compression for PPP/SLIP\n");
#endif /* VJCOMPRESS */

#endif /* PPP || SLIP */

#ifdef PACKET
	tputs("FTP Software's PACKET driver interface\n");
#endif /* PACKET */

#ifdef APPLETALK
	tputs("Appletalk interface for MacIntosh\n");
#endif /* APPLETALK */

#ifdef ARCNET
	tputs("ARCnet via PACKET driver\n");
#endif /* ARCNET */

#ifdef DRSI
	tputs("DRSI PCPA low-speed driver\n");
#endif /* DRSI */

#ifdef EAGLE
    tputs("Eagle card 8530 driver\n");
#endif /* EAGLE */

#ifdef ETHER
    tputs("Generic ethernet driver\n");
#endif /* ETHER */

#ifdef HAPN
	tputs("Hamilton Area Packet Network driver\n");
#endif /* HAPN */

#ifdef HS
	tputs("High speed (56 kbps) modem driver\n");
#endif /* HS */

#ifdef PACKETWIN
	tputs("Gracilis PackeTwin driver\n");
#endif /* PACKETWIN */

#ifdef PC_EC
	tputs("3-Com 3C501 Ethernet controller driver\n");
#endif /* PC_EC */

#ifdef PC100
	tputs("PAC-COM PC-100 driver\n");
#endif /* PC100 */

#ifdef PI
	tputs("PI SCC card with DMA driver (VE3IFB)\n");
#endif /* PI */

#ifdef SCC
    tputs("Generic SCC (8530) driver (PE1CHL)\n");
#endif /* SCC */

#ifdef SLFP
	tputs("SLFP via PACKET driver\n");
#endif /* SLFP */
    
#ifdef TRACE
	tputs("Hardware interface packet tracing code\n");
#endif /* TRACE */

#ifdef STKTRACE
	tputs("Stack tracing code\n");
#endif /* STKTRACE */

#ifdef MULTITASK
/*      tputs("The Russell Nelson modsets\n"); */
	tputs("Multitasking capability when shelling out to MS-DOS\n");
#endif /* MULTITASK */

#ifdef XSPAWN
	tputs("EMS/Disk swapping when shelling out to MS-DOS\n");
#endif /* XSPAWN */

#ifdef UNIX
    tputs("Linux/Unix/POSIX modifications by Brandon S. Allbery\n");
#endif

#ifdef MONITOR
    tputs("User port monitor trace mode\n");
#endif

#ifdef TTYCALL
    tputs("AX.25 ttylink mode\n");
#endif

#ifdef AXBCSTR
    tputs("AX.25 broadcast strings\n");
#endif

	return 0;
}

#endif /* ALLCMD */
